<html>
  <head>
    <title>Node.js WebSocket chat</title>
    <style type="text/css">
      #input {
        width: 200px;
      }

      #messages {
        position: fixed;
        top: 40px;
        bottom: 8px;
        left: 8px;
        right: 8px;
        border: 1px solid #eeeeee;
        padding: 8px;
      }
    </style>
  </head>

  <body>
    Your message:
    <input type="text" id="input" />
    <div id="messages"></div>
    <script src="http://localhost:4000/socket.io/socket.io.js"></script>
    <script type="text/javascript">
      var messagesElement = document.getElementById("messages");
      var lastMessageElement = null;
      function addMessage(message) {
        var newMessageElement = document.createElement("div");
        var newMessageText = document.createTextNode(message);
        newMessageElement.appendChild(newMessageText);
        messagesElement.insertBefore(newMessageElement, lastMessageElement);
        lastMessageElement = newMessageElement;
      }
      var socket = io.connect("http://localhost:4000");
      socket.on("serverMessage", function(content) {
        addMessage(content);
      });
      socket.on('login', ()=>{
          var username = prompt('What username would you like to use?')
          socket.emit('login', username)
      });
      const sendCommand = (command, args)=>{
          if(command === 'j'){
              socket.emit('join', args)
          }else{
              alert('unknown command: ' + command)
          }
      }

      const sendMessage = (message)=>{
          var commandMatch = message.match(/^\/(\w*)(.*)/)
          if (commandMatch){
              sendCommand(commandMatch[1], commandMatch[2].trim())
          }else{
              socket.emit('clientMessage', message)
          }
      }
      var inputElement = document.getElementById("input");
      inputElement.onkeydown = function(keyboardEvent) {
        if (keyboardEvent.keyCode === 13) {
            sendMessage(inputElement.value)
          socket.emit("clientMessage", inputElement.value);
          inputElement.value = "";
          return false;
        } else {
          return true;
        }
      };
    </script>
  </body>
</html>
